-- $Name:Зеркало$
-- $Version: 0.4.1$
game.use = '   Не получается...';
dofile('actions.lua');
dofile('part_1.lua');
dofile('part_2.lua');
dofile('part_3.lua');
dofile('part_4.lua');
--dofile('debug.lua');

game.codepage="UTF-8"
game.dsc = [[Команды:^
    look(или просто ввод), act <на что> (или просто на что), use <что> [на что], go <куда>,^
    back, inv, way, obj, quit, save <fname>, load <fname>. Работает автодополнение по табуляции.^^]];

set_music('music/title1.ogg', 1);

main = iroom {
    nam = 'ЗЕРКАЛО',
    pic = 'images/title.png',
    obj = { vway("1", txtc('{Перейти в главное меню}'), 'main2'), 
--            vway("3", "^^   {chapter 2}", 'part_1_end'),
--            vway("3", "^^   {chapter 3}", 'part_2_end'),
    },
};

main2 = iroom {
    nam = 'ЗЕРКАЛО',
    pic = 'images/title_small.png',
    enter = function (s)
        set_music('music/title2.ogg');
    end,
    desc = function(s)
        local v = txtc (txtb('   «Зеркало»^    v 0.4 beta (16.12.2009)'))..[[^^    Авторы оригинальной игры «ЗЕРКАЛО» для ZX Spectrum — творческая группа Art Work:^   Коды и музыка — Пасечник И. А.^   Сценарий и графика — Степанов В. Ю.^^   Адаптация для INSTEAD — Вадим В. Балашов.^   vvb.backup@rambler.ru^^   Автор выражает огромную признательность Петру Косых за INSTEAD и неоценимую помощь, оказанную при разработке кода.]];
        return v;
    end,
    obj = { vway("1", "   {Об авторах оригинальной игры}^", 'about'), -- i001
            vway("2", "   {Прочитать правила}^", 'p01'), -- r000
            vway("4", "   {НАЧАТЬ ИГРУ}", 'i101') }, -- i01
};


status = stat {
    _where = 'Cell',
    Life = 26,
    Cargo = 0,
    Progress = 0,
    Fatigue_Death_String = '',
    _drink_water_on_this_level = false;
    nam = function(s)
        local v = 'Здоровье: '..s.Life..'%^';
        v = v..'Нагрузка:  '..s.Cargo..'%^';
        v = v..'Прогресс:  '..s.Progress..'%^';
        return v..'^';
    end,
    life = function(s)
        if here().Add_Progress ~= nil then
            status.Progress = status.Progress + here().Add_Progress;
            here().Add_Progress = 0;
        end
        if s._where ~= me().where then
           s._where = me().where;

           if here().Del_Life then
               status.Life = status.Life - here().Del_Life;
           end
--           s.Life = s.Life - 2;
           here()._rested = nil;
        end
        if s.Life <= 0 then
           ACTION_TEXT = nil;
           return cat(s.Fatigue_Death_String, goto('The_End')), true;
        end
    end
};


about = room {
    nam = 'Об авторах',
    pic = 'images/art_work.png',
    enter = function (s)
        set_music('music/instructions.ogg');
    end,
    dsc = [[    Авторы оригинальной игры «ЗЕРКАЛО» для ZX Spectrum — творческая группа Art Work:^^
                Коды и музыка — Пасечник И. А.^
                Сценарий и графика — Степанов В. Ю.]],
    obj = { vway("1", "    {Вернуться в главное меню}", 'main2') },
};


p01 = room {
    nam = 'Инструкция',
    pic = 'images/instructions.png',
    enter = function (s)
        set_music('music/instructions.ogg');
    end,
    dsc = function(s)
        local v = txtc(txtu(txtb('Параметры игрока:')))..txtb('^   Здоровье')..[[ — показывает общее физическое состояние героя.]]..txtb('^   Нагрузка')..[[ — суммарный вес несомых объектов.]]..txtb('^   Прогресс')..[[ — общий прогресс по игре (процент прохождения игры).^^]]..txtc(txtu(txtb('Действия игрока:')))..txtb('^   С СОБОЙ')..[[ — позволяет осмотреть несомые предметы.]]..txtb('^   ВЗЯТЬ')..[[ — если это возможно, герой возьмёт указанный предмет.]]..txtb('^   БРОСИТЬ')..[[ — лишние предметы можно оставить.]]..txtb('^   ИСПОЛЬЗОВАТЬ')..[[ — для достижения цели игры герою придётся работать с окружающими его объектами. Для этого Вы должны указать КАКИМ (первый клик) предметом нужно действовать на КАКОЙ (второй клик) предмет. Чтобы использовать объект сам по себе, его нужно выбрать ДВАЖДЫ.]]..txtb('^   ГОВОРИТЬ')..[[ — с некоторыми персонажами герой может разговаривать.]]..txtb('^   ОТДАТЬ')..[[ — здесь Вы должны выбрать КАКОЙ (первый клик) предмет, из имеющихся у Вас, надо отдать КОМУ (второй клик).]]..txtb('^   ОТДЫХАТЬ')..[[ — поможет восстановить утраченную жизненную энергию, но отдыхать нужно осторожно.]]..txtb('^^   Примечание^')..[[   В меню ИСПОЛЬЗОВАТЬ и ОТДАТЬ курсивом отмечаются те предметы, которые у Вас с собой.]];
        return v;
    end,
    obj = { vway("1", "   {Вернуться в главное меню}", 'main2') },
};
