i101 = room {
    nam = 'Предисловие',
    pic = 'images/movie_101.png',
    enter = function(s)
        set_music('music/movie.ogg');
    end,
    dsc = [[   Тёмное дождливое утро встретило неподвижное войско людей посреди широкого поля...]],
--    obj = { vway("1", "{Главное меню}^^", 'main2'),
--            vway("3", "{ДАЛЕЕ}", 'i02') },
    way = { vroom ('Назад', 'main2'),
            vroom ('ДАЛЕЕ', 'i102') }
};


i102 = room {
    nam = 'Предисловие',
    pic = 'images/movie_102.gif',
    dsc = [[   Людям предстояла решающая битва с жестоким и грозным противником.]],
    way = { vroom ('Назад', 'i101'),
            vroom ('ДАЛЕЕ', 'i103') }
};


i103 = room {
    nam = 'Предисловие',
    pic = 'images/movie_103.gif',
    dsc = [[   Орды орков и гоблинов во главе с Рыцарем Тьмы и его Чёрным Магом напали на страну.]],
    way = { vroom ('Назад', 'i102'),
            vroom ('ДАЛЕЕ', 'i104') }
};


i104 = room {
    nam = 'Предисловие',
    pic = 'images/movie_104.gif',
    dsc = [[   — Вперёд, мои верные слуги! Я хочу, чтобы был мёртв каждый, кто осмелился восстать против меня!]],
    way = { vroom ('Назад', 'i103'),
            vroom ('ДАЛЕЕ', 'i105') }
};


i105 = room {
    nam = 'Предисловие',
    pic = 'images/movie_105.png',
    dsc = [[   И разгорелась кровавая битва.]],
    way = { vroom ('Назад', 'i104'),
            vroom ('ДАЛЕЕ', 'i106') }
};


i106 = room {
    nam = 'Предисловие',
    pic = 'images/movie_106.gif',
    dsc = [[   Много часов продолжалось это жестокое побоище.]],
    way = { vroom ('Назад', 'i105'),
            vroom ('ДАЛЕЕ', 'i107') }
};


i107 = room {
    nam = 'Предисловие',
    pic = 'images/movie_107.gif',
    dsc = [[   Все силы были брошены в борьбу.]],
    way = { vroom ('Назад', 'i106'),
            vroom ('ДАЛЕЕ', 'i108') }
};


i108 = room {
    nam = 'Предисловие',
    pic = 'images/movie_108.png',
    dsc = [[   Но слишком немногочисленно было войско людей. Близка была победа тёмных сил...]],
    way = { vroom ('Назад', 'i107'),
            vroom ('ДАЛЕЕ', 'i109') }
};


i109 = room {
    nam = 'Предисловие',
    pic = 'images/movie_109.gif',
    dsc = [[   И тогда люди решили прибегнуть к последнему средству — Волшебному Зеркалу. Ценой энергии многих воинов из Зеркала был вызван Демон Войны.]],
    way = { vroom ('Назад', 'i108'),
            vroom ('ДАЛЕЕ', 'i110') }
};


i110 = room {
    nam = 'Предисловие',
    pic = 'images/movie_110.gif',
    dsc = [[   Как смерч Демон пронёсся над полем битвы, сокрушая воинов зла. Был повержен и Рыцарь Тьмы.]],
    way = { vroom ('Назад', 'i109'),
            vroom ('ДАЛЕЕ', 'i111') }
};


i111 = room {
    nam = 'Предисловие',
    pic = 'images/movie_111.gif',
    dsc = [[   И вот последние враги уничтожены. Много доблестных воинов полегло в этом бою. Они пали, сохранив мир и свободу живым.]],
    way = { vroom ('Назад', 'i110'),
            vroom ('ДАЛЕЕ', 'i112') }
};


i112 = room {
    nam = 'Предисловие',
    pic = 'images/movie_112.png',
    dsc = [[   Но Чёрному Магу удалось бежать с поля битвы.^^   Прошло два столетия, и Маг вернулся. Назвав себя Чёрным Властелином, он собрал огромные полчища гоблинов и орков. Тёмные силы быстро захватили страну, и люди не смогли противостоять им...]],
    way = { vroom ('Назад', 'i111'),
            vroom ('ДАЛЕЕ', 'Cell_entry') }
};


-- ----------------------------------------------------------------------

door = iobj {
    nam = 'дверь',
    desc = function(s)
        return "   В темноте видна решётчатая {дверь}.";
    end,
    exam = function(s)
        if (chain._chain_on) then
            return '   Цепь не позволяла мне добраться даже до середины камеры, и в полумраке я видел только общие контуры.';
        else
            if Cell._cell_locked then
                lock:enable();
            end
            return '   Крепкая решётчатая дверь с массивным замком.';
        end
    end,
    obj = { 'lock' },
};


lock = iobj {
    nam = 'замок',
    desc = function(s)
        if Cell._cell_locked then
            return "Дверь заперта на железный {замок}.";
        else
            return "{Замок} открыт.";
        end
    end,
    exam = [[   Массивный железный замок. Ржавый, но крепкий...]],
    used = function (s, w)
        if w == 'rod' and Cell._cell_locked then
            if have ('rod') then
                Cell._cell_locked = false;
                Drop(rod);
                rod:disable();
                lifeon('guardian');
                return "   Вставленный в замочную скважину прут зацепил скрытый механизм. Внутри что-то щёлкнуло, и дверь открылась.";
            else
                return "   У меня нет прута.";
            end
        end
    end,
}: disable();


plate = iobj {
    nam = 'тарелка',
    weight = 6,
    desc = function(s)
        return "На полу стоит {тарелка}.";
    end,
    exam = function (s)
        return "   Грубая глиняная тарелка, наполненная каким-то жиром с неприятным запахом.";
    end,
    take = function(s)
        return "   Я взял тарелку.";
    end,
    drop = function(s)
        if chain._chain_on then
            return '   Она мне ещё пригодится.', false;
        else
            plate:disable();
            shard:enable();
            return '   Ударившись о каменный пол, тарелка разлетелась на осколки.', true;
        end
    end,
    useit = function (s)
        if have('plate') then
            return "  Содержимое тарелки выглядело настолько отвратительно, что я не отважился его попробовать.";
        else
            return "  У меня нет тарелки.";
        end
    end,
};


shard = iobj {
    nam = 'осколок',
    weight = 2,
    desc = function(s)
        return "На полу лежит {осколок}.";
    end,
    exam = function (s)
        return "   Острый осколок от глиняной тарелки.";
    end,
    take = function(s)
        return "   Я взял осколок.";
    end,
    drop = function(s)
        return "   Я бросил осколок на пол.";
    end,
    useit = function (s)
        return "   Острый.";
    end,
}:disable();


window = iobj {
    nam = 'окно',
    desc = function(s)
        return "Из маленького {окна} льётся призрачный свет.";
    end,
    exam = function(s)
        if (chain._chain_on) then
             return "   Цепь не позволяла мне добраться даже до середины камеры, и в полумраке я видел только общие контуры.";
        else
             if Cell._rod_attached then
                 rod:enable();
                 return "   Просто небольшое отверстие в стене, забранное тонкими железными прутьями, один из которых сильно расшатался.";
             else
                 return "   Просто небольшое отверстие в стене, забранное тонкими железными прутьями. Одного прута не хватает.";
             end
        end
    end,
    obj = { 'rod' },
};


rod = iobj {
    nam = 'прут',
    weight = 20,
    desc = function(s)
        if Cell._rod_attached then
            return 'Один из {прутьев} в оконной решётке шатается.';
        else
            return '{Прут} лежит на полу.';
        end
    end,
    exam = [[   Тонкий железный прут.]],
    take = function(s)
        if Cell._rod_attached then
            return '   Прут шатается, но вырвать его не получается.', false;
        else
            return '   Я взял прут.', true;
        end
    end,
    drop = function(s)
        return '   Я бросил прут на пол.';
    end,
    used = function (s, w)
        if w == 'shard' then
            if have ('shard') then
                Cell._rod_attached = false;
                Drop(shard);
                shard:disable();
                return '   Осколком я расшатал камень, удерживающий прут, и за секунду до того, как глина рассыпалась в моих руках, прут упал на пол.';
            else
                return '   У меня нет осколка.';
            end
        end
    end,
}: disable();


chain = iobj {
    nam = 'цепь',
    weight = 43,
    _chain_on = true,
    _chain_attached = true,
    desc = function(s)
        if chain._chain_on then
            return 'Я прикован {цепью} к стене.';
        elseif chain._chain_attached then
            return '{Цепь} лежит на полу, одним концом она прикована к стене.';
        else
            if here() == Tunnel_Out then
                return 'На земле лежит {цепь}.';
            end
            if here() == Dark_Room then
                if Dark_Room._chain_on_hook then
                    return 'На балке висит {цепь}. Её конец зацеплен за крюк.';
                end
                if Dark_Room._chain_on_beam then
                    return 'На балке висит {цепь}.';
                end
            end
            return '{Цепь} лежит на полу.';
        end
    end,
    exam = [[   Длинная ржавая цепь с кандалами и тяжёлым железным ядром.]],
    take = function(s)
        if s._chain_attached then
            return '   Это невозможно — цепь прикована к стене.', false;
        else
            if here() == Dark_Room then
                if Dark_Room._chain_on_lid_opened then
                    Dark_Room._chain_on_beam = false;
                    Dark_Room._chain_on_hook = false;
                    Dark_Room._chain_on_lid_opened = false;
                    Dark_Room._chain_off_lid_opened = true;
                    return '   Я снял цепь с балки.';
                end
                if Dark_Room._chain_on_beam then
                    Dark_Room._chain_on_beam = false;
                    Dark_Room._chain_on_hook = false;
                    return '   Я снял цепь с балки.';
                end
                if Dark_Room._chain_on_hook then
                    Dark_Room._chain_on_beam = false;
                    Dark_Room._chain_on_hook = false;
                    return '   Я снял цепь с балки.';
                end
                return '   Я взял цепь.';
            end
            return '   Я взял цепь.', true;
        end
    end,
    drop = function(s)
        if here() == Dark_Room and not Dark_Room._light_on then
            chain:disable();
        end
        if here() == Tunnel_Out then
            return '   Я бросил цепь на землю.';
        end
        return '   Я бросил цепь на пол.';
    end,
    useit = function(s)
        if here() == Dark_Room then
            if Dark_Room._chain_on_lid_opened then
                return '   Я уже открыл лаз.';
            end
            if Dark_Room._chain_on_hook then
                Dark_Room._chain_on_lid_opened = true;
                ways(Dark_Room):add(vroom ('Лаз', 'Tunnel'));
                return '   Буквально повиснув на цепи, я привёл в действие свой нехитрый механизм. Камень поддался, и на его месте открылся тёмный лаз.';
            end
        end
        return '   Я попытался порвать цепь. Безрезультатно.';
    end,
    used = function (s, w)
        if w == 'plate' then
            if have ('plate') then
                if s._chain_on then
                    s._chain_on = false;
                    return '   Превознемогая отвращение, я зачерпнул немного жира из тарелки и смазал им кисти рук. Плохо подогнанные кандалы с лёгкостью соскользнули на пол.';
                else
                    return '   Я уже освободился от цепи. Незачем лишний раз пачкать руки.';
                end
            else
                return '   У меня нет тарелки.';
            end
        end
        if w == 'rod' and s._chain_attached then
            if have ('rod') then
                s._chain_attached = false;
                return '   Я отогнул скобы, крепившие цепь к стене.';
            else
                return '   У меня нет прута.';
            end
        end
    end,
};


GOING = 0;
ENTER = 1;
BEAT  = 2;
DEAD  = 3;

guardian = iobj {
    nam = 'гоблин',
    weight = 101,
    desc = function(s)
        local st={
                  'В двери стоит {гоблин}.',
                  '{Гоблин} зол.',
                  '{Гоблин} лежит на полу.'
                 }
        return st[s._state];
    end,
    exam = [[   Мерзкий грязный гоблин в старой кольчуге и рогатом шлеме.]],
    life = function(s)
        if not s._state then
            s._state = GOING
            return
        end
        if s._state == GOING then
            put('guardian');
            s._state = ENTER; -- стражник зашёл
            return '   Не успел я что-либо предпринять, как передо мной возник здоровенный гоблин, грозно обнажая оружие.', true;
        end
        if s._state == ENTER then
            s._state = BEAT; -- стражник бъёт
            return '   Не дожидаясь нападения с моей стороны, гоблин взмахнул мечом...', true;
        end
        lifeoff(s);
        me():disable_all();
        return cat('   Удар был быстрый и сильный. В глазах потемнело...', goto('The_End'));
    end,
    take = function(s)
    end,
    talk = function(s)
        if guardian._state == DEAD then
            return '   Бесполезно. Гоблин в бессознательном состоянии.';
        else
            return '   Гоблин только зарычал в ответ...';
        end
    end,
    used = function(s, w)
        if w == 'chain' then
            if have 'chain' then
                if (s._state ~= DEAD) then
                    s._state = DEAD; -- стражник в ауте
                    lifeoff(s);
                    return '   Размахнувшись, я со всей силы ударил гоблина цепью по рогатому шлему. Явно не ожидавший такого поворота событий, охранник без сознания повалился на пол.';
                else
                    return '   Незачем бить гоблина цепью ещё раз. Он больше мне не помешает.';
                end
            else
                return '   У меня нет цепи.';
            end
        end
    end
};


guardians = iobj {
    nam = 'гоблины',
    life = function(s)
        if not s._state then
            s._state = GOING
            return '   Вдруг снизу донёсся топот ног, лязг оружия и грязная ругань охранников. На лестнице заиграли отблески факелов.', false;
        end
        if s._state == GOING then
            return cat ('   Я немного замешкался на лестнице и столкнулся с бегущими вверх гоблинами. Их злобный вид не обещал ничего хорошего.', goto('Entryway_Death')), true;
        end
    end,
};


Cell_entry = iroom {
    nam =  "???",
    desc = [[   ...Холодные каменные стены. Пронизывающий ветер жёг тело...^
                ...Яркий свет факела, поднесённого прямо к лицу, ослепил меня. Откуда-то издалека до меня донеслись обрывки речи. Кричали, видимо требуя чего-то... Я никак не мог поймать нить событий, и это сбивало с толку.^
                ...Двое гоблинов схватили меня под руки и потащили по длинным холодным коридорам...]];
    enter = function(s)
        set_music('music/part_1.ogg');
    end,
    obj = { vway("1", "   {Далее}", 'Cell') },
    exit = function (s, t)
            me().obj:add('status');
            actions_init();
            lifeon('status');
            status.Fatigue_Death_String = '   Долгие скитания по мрачным коридорам замка отняли у меня последние силы.^   Потеряв сознание, я упал на холодный пол.';
    end,
};


Cell = iroom {
    nam =  "Камера",
    _cell_locked = true,
    _rod_attached = true,
    Add_Life_Rest = 52,
    Del_Life = 2,
    pic = function(s)
        if s._cell_locked then
             return 'images/cell_locked.png';
        else
             if guardian._state == GOING then
                 return 'images/cell_opened.png';
             end
             if guardian._state == ENTER then
                 return 'images/guard_enter.png';
             end
             if guardian._state == BEAT then
                 return 'images/guard_beat.png';
             end
             if guardian._state == DEAD then
                 return 'images/guard_dead.png';
             end
        end
    end,
    desc = function (s)
        if s._cell_locked then
            return [[   Голоса и шаги медленно стихали, растворяясь в полной темноте.^
                Я открыл глаза. Благодарение небесам — это был лишь сон. Но жуткая реальность казалась продолжением ночных кошмаров.^
                Я лежал, прикованный цепью к неровной каменной стене. Сырая камера тонула в ночном полумраке. Призрачный свет, льющийся в маленькое окошко, выхватывал из мрака тёмный силуэт двери.^
                Разминая затёкшие руки, я отодвинул стоящую рядом тарелку и попытался вспомнить, как я здесь оказался. Странно, но прошлое было для меня загадкой.]];
        else
            return "   Я вошёл в камеру. Холодный полумрак напомнил мне о том неприятном времени, которое я провёл здесь в оковах.";
        end
    end,
    rest = function(s)
        if s._cell_locked then
            return '   Кое-как устроившись на холодном полу, я провёл несколько часов в тревожном полусне.';
        else
            return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
        end
    end,
    rested = [[   Мне больше не хотелось валяться на этом грязном и холодном полу.]],
    obj = { 'door', 'plate', 'window', 'chain', 'shard' },
    way = { vroom('Дверь', 'Entryway') },
    exit = function (s, t)
        if t == 'The_End' then
           return
        end
        if s._cell_locked then
            return '   Дверь заперта.', false
        end
        if guardian._state ~= DEAD then
--            return '   Гоблин не даёт выйти.', false
            return nil, false
        end
    end,
};


flint = iobj {
    nam = 'кремень',
    weight = 2,
    desc = function(s)
        return 'Я вижу {кремень}.';
    end,
    exam = [[   Небольшой кремень.]],
    take = function(s)
        if have('barrel') then
            return '   Тяжёлая бочка сковывала движения — я ничего не мог сделать.', false;
        end
        chest1._flint_inside = false;
        return "   Я взял кремень.";
    end,
    drop = function(s)
        if here() == Dark_Room and not Dark_Room._light_on then
            return '   Если я брошу кремень здесь, то в темноте я не смогу его найти.', false;
        end
--        if here() == Dark_Room then
--            return '   Если я брошу здесь кремень, я его потом не смогу найти.', false;
--        else
            return "   Я бросил кремень.";
--        end
    end,
}:disable();


chest1 = iobj {
    nam = 'сундук',
    weight = 101,
    _flint_inside = true;
    desc = function(s)
        return '   В углу стоял окованный железом полуоткрытый {сундук}.';
    end,
    exam = function(s)
       if s._flint_inside then
           flint:enable();
           return "   Старый оббитый железом ящик с полусгнившими досками. Внутри, как и везде в этом замке, было полно мусора, среди которого я заметил почти целый кремень.";
       else
           return "   Старый оббитый железом ящик с полусгнившими досками. Внутри, как и везде в этом замке, было полно мусора.";
       end
    end,
    take = function(s)
    end,
    useit = function(s)
        if (guardians._state ~= DEAD) then
            guardians._state = DEAD; -- стражники в ауте
            lifeoff(guardians);
            Entryway._guardians_alert = false;
            return cat ('', goto('Guardians_quarrel'));
        else
            return '   Больше нет необходимости прятаться — опасность уже миновала.';
        end
    end,
    obj = { 'flint' }
};


Entryway = iroom {
    _guardians_alert = true,
    Del_Life = 2,
    nam =  "Лестничная площадка",
    pic = 'images/entryway.png',
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    desc = function(s)
        if s._guardians_alert then
            return '   За решётчатой дверью оказалась лестничная площадка, вверх и вниз от которой вела винтовая лестница.';
        else
            return '   Лестничная площадка. Извиваясь, ступени ведут вверх и вниз. Чёрная дыра — вход в камеру.';
        end
    end,
    enter = function(s)
        if s._guardians_alert then
            lifeon('guardians');
        end
    end,
    obj = { 'chest1' },
    way = { vroom ('Вниз', 'Prison_Bottom'), 'Cell', vroom ('Вверх', 'Prison_Top') },
    exit = function(s, to)
        if to == 'Entryway_Death' then
            lifeoff('guardians');
            return
        end
        if s._guardians_alert then
            return nil, false -- охранники бегут. убежать нельзя.
        end
    end,
};


Guardians_quarrel = iroom {
    nam =  "Лестничная площадка",
    pic = 'images/guardians_quarrel.png',
--    Add_Progress = 3,
    desc = [[   Не теряя ни секунды, я бросился к старому ящику и, открыв крышку, спрятался в нём. И во время...^
                На лестничную площадку выбежали заспанные гоблины, размахивая оружием и факелами. По-видимому, мой побег застал их врасплох, и они заметались из стороны в сторону, не зная что предпринять.^
                — Жалкое отродье!!! Мерзкие твари!!! Вам в болотах пиявок собирать, а не служить Чёрному Властелину! — разлетался по каменным коридорам визгливый голос командира.^
                — Ну, мы... Мы ведь... Понимаете...^
                — Да вы знаете что он с вами за это сделает! Гнить вам в подземельях Трёхглавого Замка! Позволили сбежать негодяю за три часа до прибытия самого Чёрного Властелина! Немедленно перекрыть все входы и выходы!^
                Перепуганные гоблины помчались исполнять приказ командира.^
                Когда эхо тяжёлого топота охранников затихло в отдалении, я осторожно выбрался из ящика.]],
    enter = function(s)
        status.Progress = status.Progress + 3; -- поскольку disable_all вырубает status
        me():disable_all();
    end,
--    way = { vroom ('Далее', 'Entryway') },
    obj = { vway("1", "   {Далее}", 'Entryway') },
    exit = function(s)
        me():enable_all();
    end,
};


Entryway_Death = iroom {
    nam =  "Лестничная площадка",
    pic = 'images/entryway_guardians.png',
--    desc = [[   Я немного замешкался на лестнице и столкнулся с бегущими вверх гоблинами. Их злобный вид не обещал ничего хорошего.]],
    enter = function(s)
        me():disable_all();
    end,
--    way = { vroom ('Далее', 'Entryway') },
    obj = { vway("1", "   {Далее}", 'The_End') },
};




observe_area = iobj {
    nam = 'площадка',
    desc = function(s)
        return '   Я стоял на просторной смотровой {площадке}.';
    end,
    exam = function(s)
        if Prison_Top._torch_present then
            torch:enable();
            return '   По-видимому, здесь уже давно никого не было: пол устлан слоем мусора и грязи, в углах чернели кучи принесённых ветром листьев. Около лестницы одиноко валялся старый факел...';
        else
            return '   По-видимому, здесь уже давно никого не было: пол устлан слоем мусора и грязи, в углах чернели кучи принесённых ветром листьев.';
        end
    end,
    obj = { 'torch' },
};




Prison_Top = iroom {
    nam =  "Смотровая площадка",
    Del_Life = 2,
    Add_Progress = 5,
    _torch_present = true,
    pic = 'images/prison_top.png',
    desc = [[   Опасаясь появления гоблинов, я осторожно поднялся вверх по винтовой лестнице, которая привела меня на просторную смотровую площадку.^
                Я остановился, поражённый открывшимся видом. Передо мной на многие сотни миль раскинулась мрачная страна, опоясанная цепью далёких гор. На фоне тёмных туч грозно возвышался Трёхглавый Замок.^
                Странно, но мой взор постоянно возвращался к Замку. Он притягивал к себе, внушая непонятный страх. В памяти возник его образ, но тут же растаял, и я никак не мог вспомнить, когда видел эту чёрную крепость.]],
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    obj = { 'observe_area' },
    way = { vroom ('Вниз', 'Entryway') },
};


door_out = iobj {
    nam = 'дверь',
    desc = function(s)
        return '   Я вижу большую деревянную {дверь}.';
    end,
    exam = function(s)
       return "   Окованная железом крепкая дубовая дверь. По-видимому, она вела к выходу из замка.";
    end,
    useit = function(s)
        return cat('   За дверью оказался длинный коридор, в конце которого виднелся выход из замка.^   Но путь мне преградил отряд гоблинов, и лишь сейчас я вспомнил разговор, подслушанный мной на лестничной площадке.', goto('Guardians_Death'));
    end,
    used = function(s, w)
        if w == 'chain' then
            return cat('   Удар железным ядром цепи вызвал гулкое эхо в глубине коридора.^   Но тут же передо мной появились гоблины-охранники, и я пожалел о содеянном...', goto('Guardians_Enter'));
        end
    end
};



Prison_Bottom = iroom {
    nam =  "Коридор",
    Del_Life = 2,
    pic = 'images/prison_bottom.png',
    desc = [[   Слабый свет нескольких факелов едва разгонял мрак коридора, бросая дрожащие тени на полуприкрытую дверь и уходящие вверх ступени лестницы.]],
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    obj = { 'door_out' },
    way = { vroom ('Дверь', 'The_End'), vroom ('Вверх', 'Entryway'), vroom ('Тёмный ход', 'Dark_Room') },
    exit = function(s, to)
        if to == 'The_End' then
            return cat('   За дверью оказался длинный коридор, в конце которого виднелся выход из замка.^   Но путь мне преградил отряд гоблинов, и лишь сейчас я вспомнил разговор, подслушанный мной на лестничной площадке.', goto('Guardians_Enter'));
        end
    end,
};


torch = iobj {
    nam = 'факел',
    weight = 10,
    desc = function(s)
        if here() == Dark_Room then
            return 'Старый {факел} висит на стене.';
        else
            return 'Около лестницы одиноко валялся старый {факел}.';
        end
    end,
    exam = [[   Старый факел.]],
    take = function(s)
        Prison_Top._torch_present = false;
        if here() == Dark_Room then
            if seen(flint) then
                return '   Если я оставлю кремень здесь, потом, в темноте я не смогу его найти.', false;
            end
            if seen(chain) then
                chain:disable();
            end
            if Dark_Room._chain_on_lid_opened or Dark_Room._chain_off_lid_opened then
                ways(Dark_Room):del('Лаз');
            end
            beam:disable();
            hook:disable();
            Dark_Room._light_on = false;
            ways(Prison_Bottom):del('Ход');
            ways(Prison_Bottom):add(vroom ('Тёмный ход', 'Dark_Room'));
            return '   Сняв факел со стены, я потушил его. Комната погрузилась во тьму.';
        else
            return '   Я взял факел.';
        end
    end,
    drop = function(s)
        if here() == Dark_Room then
            return '   Если я брошу здесь факел, я его потом не смогу найти.', false;
        else
            return '   Я бросил факел на пол.', true;
        end
    end,
    used = function (s, w)
        if w == 'flint' and have ('flint') and have ('torch') then
            if here() == Dark_Room then
                if Dark_Room._chain_on_lid_opened or Dark_Room._chain_off_lid_opened then
                    ways(Dark_Room):add(vroom ('Лаз', 'Tunnel'));
                end
                Dark_Room._light_on = true;
                ways(Prison_Bottom):del('Тёмный ход');
                ways(Prison_Bottom):add(vroom ('Ход', 'Dark_Room'));
                inv():del('torch');
                do_drop('torch', Dark_Room);
                beam:enable();
                hook:enable();
                if seen(chain) then
                    chain:enable();
                end
                return cat ('   Ударив кремнем о неровный камень стены, я зажёг факел и укрепил его возле двери.^   Комнатой давно никто не пользовался: поросшие мхом камни, свисающие с потолка паутина и сырой пол красноречиво свидетельствовали об этом.', goto(here()));
            else
                return '   Здесь это не нужно.', false;
            end
        end
    end,
}:disable();


Dark_Room = iroom {
    nam =  "Комната",
    Del_Life = 2,
    _light_on = false,
    _chain_on_beam = false,
    _chain_on_hook = false,
    _chain_on_lid_opened = false,
    _chain_off_lid_opened = false;
    pic = function(s)
        if not s._light_on then
             return 'images/dark_room_dark.png';
        else
             if s._chain_off_lid_opened then
                 return 'images/dark_room_empty_opened.png';
             end
             if s._chain_on_lid_opened then
                 return 'images/dark_room_chain_on_lid_opened.png';
             end
             if s._chain_on_hook then
                 return 'images/dark_room_chain_on_hook.png';
             end
             if s._chain_on_beam then
                 return 'images/dark_room_chain_on_beam.png';
             end
             return 'images/dark_room_empty_closed.png';
        end
    end,
    desc = function(s)
        if not s._light_on then
             return '   Пройдя несколько шагов, я очутился в полной темноте. Всё, что можно было различить — только узкую полоску слабого света, пробивавшегося из коридора.';
        else
            if Dark_Room._chain_on_lid_opened then
                return '   Пройдя несколько шагов, я снова оказался в заброшенной комнате, ярко освещённой светом факела. В углу чернел открытый лаз.';
            else
                return '   Пройдя несколько шагов, я снова оказался в заброшенной комнате, ярко освещённой светом факела.';
            end
        end
    end,
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    obj = { 'beam', 'hook' },
    way = { vroom ('Коридор', 'Prison_Bottom') },
};


beam = iobj {
    nam = 'балка',
    desc = function(s)
        if Dark_Room._light_on then
            return '    Комната была практически пуста — однообразие голых стен нарушали лишь {балка} в углу';
        end
    end,
    exam = [[   Грубо отёсанное бревно, вбитое в стену.]],
    used = function (s, w)
        if w == 'chain' then
            if Dark_Room._chain_off_lid_opened then
                return '   Нет смысла делать это повторно. Я уже открыл лаз.';
            end
            if not Dark_Room._chain_on_beam then
                Dark_Room._chain_on_beam = true;
                Drop (chain);
                return '   Как следует размахнувшись, я перекинул цепь через деревянную балку.';
            else
                return '   Цепь уже висит на балке.';
            end
        end
    end,
}:disable();


hook = iobj {
    nam = 'крюк',
    desc = function(s)
        if Dark_Room._light_on then
            return ' и железный {крюк}, вбитый в пол.';
        end
    end,
    exam = [[   Ржавый железный крюк торчит из пола.]],
    take = function(s)
        return '   Ухватившись обеими руками за крюк я попытался вырвать его из пола, но у меня ничего не получилось — я лишь немного приподнял камень, в который крюк был вбит.', false;
    end,
    used = function (s, w)
        if w == 'chain' then
            if Dark_Room._chain_off_lid_opened then
                return '   Нет смысла делать это повторно. Я уже открыл лаз.';
            end
            if Dark_Room._chain_on_hook then
                return '   Я уже зацепил цепь за крюк.';
            end
            if Dark_Room._chain_on_beam then
                Dark_Room._chain_on_hook = true;
                return '   Я зацепил за крюк конец свисающей с балки цепи.';
            else
                return '   При помощи цепи я попытался вытащить камень с крюком из пола, но он был слишком тяжёл, и мои усилия пропали даром.';
            end
        end
    end,
}:disable();


Tunnel = iroom {
    nam = 'Туннель',
    pic = 'images/tunnel.png',
    Del_Life = 2,
    enter = function (s, from)
        if from == 'Dark_Room' then
            status.Life = status.Life - 10;
            return '   Я несколько необдуманно бросился в тёмный лаз, так как лететь пришлось довольно долго. При падении я больно ушиб локоть, но в остальном всё было нормально.^   Передо мной в темноту уходил узкий коридор, завешанный сетями паутины. Его стены кое-где обвалились, и на полу виднелись груды битых камней. По-видимому, коридором уже давно не пользовались.';
        else
            return '   Я вернулся к началу подземного хода. Позади меня в темноту уходил узкий коридор, завешанный сетями паутины. Его стены кое-где обвалились, и на полу виднелись груды битых камней.';
        end
    end,
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    way = { vroom ('Туннель', 'Tunnel_End') },
};


Tunnel_End = iroom {
    nam = 'Туннель',
    Del_Life = 2,
    pic = 'images/tunnel_end.png',
    desc = [[   Небольшая комнатка в конце подземного коридора. Полуразрушенные стены и сети паутины резко очерчены слабым светом, пробивающимся сквозь полузасыпанный выход.]],
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    way = { vroom ('Туннель', 'Tunnel'), vroom ('Вверх', 'Tunnel_Out') },
};


Tunnel_Out = iroom {
    nam = 'Выход из туннеля',
    pic = 'images/tunnel_out.png',
    Del_Life = 2,
    Add_Progress = 2,
    desc = [[   Выбравшись из мрачного коридора, я остановился, наслаждаясь порывами свежего ветра.^   Туннель выходил на берег быстрой горной реки. С шумом разбивая свои волны об огромные валуны, она, извиваясь, исчезала в тёмном лесу. Позади виднелся замок, освещённый кровавым рассветом.]],
    way = { vroom ('Вниз', 'Tunnel_End'), vroom ('Река', 'part_1_end') },
    rest = function(s)
        return cat('   ...Наверное не стоило терять бдительность в этом полном опасностей месте, но усталость взяла верх, обезоружив меня перед опасным противником...', goto('Guardians_Death'));
    end,
    exit = function(s, to)
        if to == 'The_End' then
           return
        end
        if status.Life == 0 then
            ACTION_TEXT = nil;
            return
        end
        if to == 'part_1_end' then
            if have('chain') then
                return cat('   Желая поскорее покинуть это мрачное и небезопасное место, я бросился в бурную реку. Тяжёлая цепь сковывала мои движения, тянула на дно. У меня не было сил бороться со стремительным потоком...', goto('The_End'));
            end
        return
        end
    end,
};


Guardians_Death = iroom {
    nam =  "???",
    pic = 'images/guardians_black.png',
    enter = function (s)
        me():disable_all();
    end,
    obj = { vway("1", "   {Далее}", 'The_End') },
};


Guardians_Enter = iroom {
    nam =  "Коридор",
    pic = 'images/guardians_enter.png',
    enter = function (s)
        me():disable_all();
    end,
    obj = { vway("1", "   {Далее}", 'The_End') },
};


The_End = iroom {
    nam = 'Вы проиграли',
    pic = 'images/death.gif',
    enter = function (s)
       set_music("music/game_over.ogg");
       me():disable_all();
    end,
    exit = function (s)
       me():enable_all();
    end,
};


part_1_end = iroom {
    nam =  'Выход из туннеля',
    pic = 'images/tunnel_out.png',
    desc = [[   Желая поскорее покинуть это мрачное и небезопасное место, я бросился в бурную реку, отдавая свою судьбу в руки провидения...]],
    obj = { vway("1", "   {Далее}", 'i201') },
    enter = function(s)
        status.Fatigue_Death_String = '   ...с каждым шагом моё самочувствие ухудшалось. Внезапно острая боль пронзила всё моё тело, ноги отказывались идти; я упал на землю...';
        me():disable_all();
    end,
};
